#
# u2d3.rb
#
# $Id: u2d3.rb,v 1.1 2000/11/21 03:15:31 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include NMath


nx = 21
ny = 21
xmin = -1.0
xmax = 1.0
ymin = -1.0
ymax = 1.0
dx = (xmax-xmin)/(nx-1)
dy = (ymax-ymin)/(ny-1)

u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)

#-- data ----
for j in 0..ny-1
  for i in 0..nx-1
    xi = xmin + i*dx
    yj = ymin + j*dy
    u[i,j] = xi
    v[i,j] = -yj
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
grfrm

grswnd(xmin, xmax, ymin, ymax)
uspfit
grstrf

ussttl('X', 'km', 'Y', 'km')
usdaxs

ugvect(u, nx, v, nx, nx, ny)

grcls

